from numpy import *
from pylab import *

# Results for Lysozyme molecule

Nsingle  = array([14398.,21944.,42286., 81002.,124358.,170458.])
Nstern   = array([29722.,50692.,94886.,181538.,273888.,370106.])
Ncavity  = array([14846.,22638.,43508., 83322.,127866.,175078.])
Nfull    = array([30170.,51386.,96108.,183852.,277396.,374726.])

#elemPerAng = array([1., 2., 4., 8., 12., 16.])
elemPerAng  = array([2.7, 4.04, 7.7, 14.6, 22.4, 30.6])

# Number of iterations
iterationsSingle =array([33,34,35,39,40,42])
iterationsStern  =array([37,38,41,45,47,48])
iterationsCavity =array([32,33,35,38,40,42])
iterationsFull   =array([36,38,41,45,48,49])

# GMRES time
time_gmresSingle = array([5.5,9.2,17.,31.5,52.,74.6])
time_gmresStern  = array([19.7,37.8,63.8,120.,196.5,269.2])
time_gmresCavity = array([12.,19.2,33.1,60.4,91.2,129.2])
time_gmresFull   = array([24.6,45.9,75.8,145.5,229.4,318.5])

# Total time
timeSingle = array([7.4,12.,22.,40.5,65.1,92.7])
timeStern = array([23.13,43.2,74.3,138.8,222.7,307.])
timeCavity = array([14.3,22.1,38.5,70.,105.,149.1])
timeFull = array([28.2,51.2,86.4,163.9,256.2,360.2])

# Time per iteration
timePerIterSingle = time_gmresSingle/iterationsSingle
timePerIterStern = time_gmresStern/iterationsStern
timePerIterCavity = time_gmresCavity/iterationsCavity
timePerIterFull = time_gmresFull/iterationsFull

# Esolv
EsolvSingle = array([-2401.2,-2161.8,-2089.,-2065.5,-2059.6,-2055.2])
EsolvStern  = array([-2415.,-2175.8,-2102.6,-2078.9,-2072.8,-2068.7])
EsolvCavity = array([-2439.6,-2202.5,-2131.,-2107.6,-2101.5,-2097.1])
EsolvFull   = array([-2432.9,-2195.9,-2124.2,-2101.1,-2094.9,-2090.8])


font = {'family':'serif','size':7}
rc('font',**font)

figure(figsize=(3,2), dpi=80)
'''
loglog(N, timePerIterGPU, c='k', marker='o', mfc='w', ms=5, ls=' ',label='GPU')
loglog(N, timePerIterCPU, c='k', marker='+', mfc='w', ms=5, ls=' ',label='CPU')
loglog(N,N*log10(N)/5e4,c='k',marker='None',ls=':',lw=0.8,label=None)
rc('font',**font)
text(2.5e4, 4.8e0,'NlogN',fontsize=8,rotation=25)
ylabel('Time per iteration [s]',fontsize=10)
xlabel('Number of elements',fontsize=10)
subplots_adjust(left=0.19, bottom=0.21, right=0.96, top=0.95)
#title('Average time per iteration versus number of elements')
legend(loc='lower right')
savefig('timePerIteration_singlelys.pdf')
clf()
'''
'''
N = Nsingle/1e2 
loglog(elemPerAng, timeSingle, c='k', marker='o', mfc='w', ms=5, ls=' ',label='Single')
loglog(elemPerAng, timeCavity, c='k', marker='+', mfc='w', ms=5, ls=' ',label='Cavity')
loglog(elemPerAng2, timeStern, c='k', marker='^', mfc='w', ms=5, ls=' ',label='Stern')
loglog(elemPerAng2, timeFull, c='k', marker='d', mfc='w', ms=5, ls=' ',label='Full')
loglog(N/5e1,N*log10(N)/5e0,c='k',marker='None',ls=':',lw=0.8, label=None)
rc('font',**font)
text(1e1, 3e2,r'NlogN',fontsize=6,rotation=26)
#text(1e5, 1.2e2,r'N$^2$',fontsize=12,rotation=40)
subplots_adjust(left=0.19, bottom=0.21, right=0.96, top=0.95)
ylabel('Time to solution [s]',fontsize=10)
xlabel('1/Area',fontsize=10)
legend(loc='upper left')
#title('Total time to solution versus number of elements')
savefig('time_lyscompare.pdf')
clf()
'''


semilogx(elemPerAng, EsolvSingle, c='k', marker='o', mfc='w', ms=3,ls='-',lw=0.5, label='Single')
semilogx(elemPerAng, EsolvCavity, c='k', marker='+', mfc='w', ms=3,ls='-',lw=0.5, label='Cavity')
semilogx(elemPerAng, EsolvStern, c='k', marker='^', mfc='w', ms=3,ls='-',lw=0.5, label='Stern')
semilogx(elemPerAng, EsolvFull, c='k', marker='d', mfc='w', ms=3,ls='-',lw=0.5, label='Full')
#loglog(N,6e0/N,c='k',marker='None',ls=':',label=None)
#text(2e5, 4e-5,r'$\frac{1}{N}$',fontsize=20,rotation=-40)
ylabel('$\Delta G_{solv}$ [kJ/mol]', fontsize=10)
xlabel('1/Area',fontsize=10)
#axis([10,40,-2150,-2050])
subplots_adjust(left=0.22, bottom=0.21, right=0.96, top=0.95)
#title('Relative error versus number of elements')
legend(loc='lower right')
savefig('Esolv_lyscompare.pdf')
clf()
